## interleave interleave — Folds many mono channels into one interleaved audio stream |

## Properties

GValueArray * | channel-positions | Read / Write
gboolean | channel-positions-from-input | Read / Write

## Types and Values

struct | GstInterleave

## Object Hierarchy

        GObject
        ╰── GstObject
            ╰── GstElement
                ╰── GstInterleave

## Description

Merges separate mono inputs into one interleaved stream.

This element handles all raw floating point sample formats and all signed integer sample formats. The first caps on one of the sinkpads will set the caps of the output so usually an audioconvert element should be placed before every sinkpad of interleave.

It's possible to change the number of channels while the pipeline is running by adding or removing some of the request pads but this will change the caps of the output buffers. Changing the input caps is _not_ supported yet.

The channel number of every sinkpad in the out can be retrieved from the "channel" property of the pad.

### Example launch line

    1
    gst-launch filesrc location=file.mp3 ! decodebin ! audioconvert ! "audio/x-raw-int,channels=2" ! deinterleave name=d  interleave name=i ! audioconvert ! wavenc ! filesink location=test.wav    d.src0 ! queue ! audioconvert ! i.sink1    d.src1 ! queue ! audioconvert ! i.sink0

Decodes and deinterleaves a Stereo MP3 file into separate channels and then interleaves the channels again to a WAV file with the channel with the channels exchanged.

    1
    gst-launch interleave name=i ! audioconvert ! wavenc ! filesink location=file.wav  filesrc location=file1.wav ! decodebin ! audioconvert ! "audio/x-raw-int,channels=1" ! queue ! i.sink0   filesrc location=file2.wav ! decodebin ! audioconvert ! "audio/x-raw-int,channels=1" ! queue ! i.sink1

Interleaves two Mono WAV files to a single Stereo WAV file.

## Synopsis

### Element Information

plugin | interleave
author | Andy Wingo <wingo at pobox.com>, Sebastian Dröge <slomo@circular-chaos.org>
class | Filter/Converter/Audio

### Element Pads

name | sink%d
direction | sink
presence | request
details | audio/x-raw-int, rate=(int)[ 1, 2147483647 ], channels=(int)1, endianness=(int){ 1234, 4321 }, width=(int){ 8, 16, 24, 32 }, depth=(int)[ 1, 32 ], signed=(boolean)true
| audio/x-raw-float, rate=(int)[ 1, 2147483647 ], channels=(int)1, endianness=(int){ 1234, 4321 }, width=(int){ 32, 64 }

name | src
direction | source
presence | always
details | audio/x-raw-int, rate=(int)[ 1, 2147483647 ], channels=(int)[ 1, 2147483647 ], endianness=(int){ 1234, 4321 }, width=(int){ 8, 16, 24, 32 }, depth=(int)[ 1, 32 ], signed=(boolean)true
| audio/x-raw-float, rate=(int)[ 1, 2147483647 ], channels=(int)[ 1, 2147483647 ], endianness=(int){ 1234, 4321 }, width=(int){ 32, 64 }

## Functions

## Types and Values

### struct GstInterleave

    struct GstInterleave;

## Property Details

### The `“channel-positions”` property

      “channel-positions”        GValueArray *

Channel positions: This property controls the channel positions that are used on the src caps. The number of elements should be the same as the number of sink pads and the array should contain a valid list of channel positions. The n-th element of the array is the position of the n-th sink pad.

These channel positions will only be used if they're valid and the number of elements is the same as the number of channels. If this is not given a NONE layout will be used.

Flags: Read / Write

### The `“channel-positions-from-input”` property

      “channel-positions-from-input” gboolean

Channel positions from input: If this property is set to `TRUE` the channel positions will be taken from the input caps if valid channel positions for the output can be constructed from them. If this is set to `TRUE` setting the channel-positions property overwrites this property again.

Flags: Read / Write

Default value: TRUE

## See Also

deinterleave